<template>
  <el-container
    class="experiment-mark"
    v-if="answersheetData.answers"
    style="min-height:500px"
  >
    <el-header>
      <el-row :gutter="20">
        <el-col :span="6">
          <el-card class="theme-small-headline" shadow="never">
            {{
              answersheetData.account.name !== null
                ? answersheetData.account.name
                : "测试者"
            }}
          </el-card>
        </el-col>
        <!-- <el-col :span="6">
          <el-card class="theme-small-headline" shadow="never">
            {{ answersheetData.organization }}
          </el-card>
        </el-col> -->
      </el-row>
    </el-header>
    <el-container>
      <el-main class="mark">
        <br /><br />
        <p>基础实验 <span style="color:red">已完成！</span></p>
        <br /><br />
        <div>
          <span>基础题：</span>
          <template v-for="(question, index) in answersheetData.answers">
            <div
              v-if="question.type === 'choice'"
              class="mark-base"
              :style="{ background: question.key === 1 ? 'green' : 'red' }"
              :key="'q' + index"
            >
              <template v-for="(label, index) in question.labels">
                <span :key="'an' + index + label">{{ label }}</span>
              </template>
            </div>
          </template>
          <p style="float:right">
            ({{ this.correct }}/{{
              answersheetData.choice
            }}&nbsp;&nbsp;&nbsp;正确率：{{
              ((this.correct / answersheetData.choice) * 100) | toFixedTwo
            }}%)
          </p>
        </div>
        <br /><br />
        <el-card
          v-if="!nowShow"
          class="box-card"
          style="background:#F56C6C;color:#fff"
        >
          简答题正在批阅中！
        </el-card>
        <div style="margin-bottom:50px;">
          <p>简答题</p>
          <template v-for="(short, index) in answersheetData.answers">
            <div
              v-if="short.type === 'text'"
              class="short-question m-t-30 m-b-30"
              :key="'short' + index"
              :ref="'short' + index"
            >
              <el-card shadow="never" style="margin:10px 0">
                问题{{ index + 1 }}：{{ short.question.text }}
                {{ `(满分: ${short.question.score}分)` }}
              </el-card>
              <el-card shadow="never" style="margin:10px 0">
                学生回答：{{ short.data }}
              </el-card>
              <el-input
                style="margin:10px 0"
                type="textarea"
                :autosize="{ minRows: 5, maxRows: 10 }"
                placeholder="请输入评语"
                v-model="short.comment"
                v-show="!answersheetData.isEnd"
                v-if="nowShow"
              >
              </el-input>
              <div class="flex row" v-if="nowShow && !answersheetData.isEnd">
                <span class="m-t-25">评分：</span
                ><el-input
                  class="mark-input"
                  v-model="short.score"
                  v-show="!answersheetData.isEnd"
                ></el-input>
              </div>
              <span v-show="answersheetData.isEnd"
                >评分：{{ short.score }}</span
              >
              <div class="m-t-10 m-b-10">
                <span v-show="answersheetData.isEnd"
                  >评语：{{ short.comment }}</span
                >
              </div>
            </div>
          </template>
        </div>
      </el-main>
      <el-aside width="200px" class="mark-aside">
        <p style="padding-left:35px">分数统计</p>
        <el-card class="theme-small-headline mark-vr" shadow="never">
          {{ vrScore }}
        </el-card>
        <el-card class="theme-small-headline mark-choice" shadow="never">
          {{ choiceScore | toFixedInt }}
        </el-card>
        <el-card
          v-show="nowShow"
          class="theme-small-headline mark-short"
          shadow="never"
        >
          {{ shortScore }}
        </el-card>
        <el-card class="theme-small-headline mark-all-score" shadow="never">
          <div slot="header" class="clearfix" style="padding:0!important">
            <span>总分</span>
          </div>
          <div
            style="color:red"
            v-if="answersheetData && answersheetData.isEnd"
          >
            {{ (shortScore + choiceScore + vrScore) | toFixedInt }}
          </div>
          <div v-else style="color:red">
            待批阅
          </div>
        </el-card>
      </el-aside>
    </el-container>
    <el-footer style="line-height:130px;" v-show="nowShow">
      <el-button
        type="danger"
        style="margin:0 15px;"
        @click="commit"
        v-show="!answersheetData.isEnd"
        >提交评分</el-button
      >
      <el-button type="info" style="margin:0 15px" @click="cancel"
        >返回</el-button
      >
    </el-footer>
  </el-container>
</template>

<script>
export default {
  name: "experimentMark",
  props: {
    markData: {
      type: Object,
      default: () => {}
    },
    nowShow: {
      type: Boolean,
      default: true
    }
  },
  filters: {
    toFixedTwo(value) {
      return value.toFixed(2);
    },
    toFixedInt(value) {
      return value.toFixed(0);
    }
  },
  methods: {
    formatData() {
      let temp = this.markData;
      temp.choice = 0;
      temp.answers.map(an => {
        an.length = 0;
        if (an.type === "choice") {
          temp.choice++;
          an.data = JSON.parse(an.data);
          an.labels = [];
          an.data.answers.map(a => {
            an.labels.push(a.label);
            if (an.data.sures.find(s => s.id === a.id)) {
              an.length = 1 + an.length;
            } else {
              an.length = 0 + an.length;
            }
          });
          if (an.length === an.data.sures.length) {
            an.key = 1;
          } else {
            an.key = 0;
          }
        }
      });
      return temp;
    },
    commit() {
      const answersheetItems = this.answersheetData.answers
        .map(data => {
          if (data.type === "text") return data;
          return null;
        })
        .filter(a => a);
      this.$emit("commitMark", answersheetItems);
    },
    cancel() {
      this.$emit("cancel");
    }
  },
  computed: {
    correct() {
      let i = 0;
      if (this.answersheetData.answers) {
        this.answersheetData.answers.map(q => {
          if (q.key === 1) {
            i++;
          }
        });
      }
      return i;
    },
    vrScore() {
      if (this.answersheetData.lab) return this.answersheetData.lab.vrScore;
      return 40;
    },
    choiceScore() {
      let score = 0;
      this.answersheetData.answers
        .filter(item => item.type === "choice")
        .forEach(val => {
          score += val.score || 0;
        });
      return score;
    },
    shortScore() {
      let score = 0;
      this.answersheetData.answers.map(s => {
        if (s.type === "text") {
          if (s.score) {
            score = score + parseInt(s.score);
          }
        }
      });
      return score;
    },
    answersheetData() {
      if (this.markData.answers) {
        return this.formatData();
      } else {
        return {};
      }
    }
  }
};
</script>

<style lang="scss" scope>
@import "@/styles/theme.scss";

.experiment-mark {
  .mark {
    text-align: left;
    border-right: 1px solid #eee;

    .mark-base {
      display: inline-block;
      width: 30px;
      height: 30px;
      margin: 10px;
      color: #fff;
      line-height: 30px;
      text-align: center;
    }

    .mark-input {
      margin: 10px 0 30px;
      display: inline-block;
      width: 50%;
    }
  }

  .mark-aside {
    border-left: 1px solid #eee;
    position: relative;
    .mark-vr {
      margin-left: 35px;
      color: red;
    }

    .mark-choice {
      margin-left: 35px;
      color: red;
      padding: 20px 0;
    }

    .mark-short {
      margin-left: 35px;
      color: red;
      padding: 20px 0;
    }

    .mark-all-score {
      margin-left: 35px;
      padding: 20px 0;
      position: absolute;
      bottom: 0;
      width: 164px;
    }
  }
  .el-card__header {
    padding: 5px 20px;
  }
  .el-card__body {
    border: 1px solid #000;
  }
  .el-card {
    border: 0px;
  }
}
</style>
